# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`pgbouncer`](#pgbouncer): Installs the pbouncer package and configures the ini.
* [`pgbouncer::params`](#pgbouncerparams): Parameters to be set for pgbouncer

## Classes

### pgbouncer

Installs the pbouncer package and configures the ini.

#### Parameters

The following parameters are available in the `pgbouncer` class.

##### `databases`

Data type: `Array[String]`

An array of entries to be written to the databases section in the
pbbouncer.ini
Array entry format:
  database_alias_name = connection_string

Default value: ['']

##### `logfile`

Data type: `String`

The full path to the log file.

Default value: $pgbouncer::params::logfile

##### `pidfile`

Data type: `String`

The full path to the pid file for the pgbouncer process.
Default: OS dependant, see params class.

Default value: $pgbouncer::params::pidfile

##### `listen_addr`

Data type: `String`

The address that are listened to by pgbouncer.

Default value: '*'

##### `listen_port`

Data type: `String`

The port for pgbouncer to listen on.

Default value: '6432'

##### `admin_users`

Data type: `String`

A comma-seperated list of users allowed to access the admin console who
then can perform connection pool management operations and obtain
information about the connection pools.

Default value: 'postgres'

##### `stats_users`

Data type: `String`

A comma-seperated list of users allowed to access the admin console
who can obtain information about the connection pools.

Default value: 'postgres'

##### `owner_user`

Data type: `String`

User who owns userlist.txt (and potentially other files). Should be
changed to the user pgbouncer runs as.
Default: OS dependant, see params class.

Default value: $pgbouncer::params::owner_user

##### `owner_group`

Data type: `String`

Group which owns userlist.txt (and potentially other files). Should be
changed to the group pgbouncer runs as if not 'postgres'.
Default: OS dependant, see params class.

Default value: $pgbouncer::params::owner_group

##### `userlist_mode`

Data type: `String`

The mode for the userlist.txt files.
Default: '0600'

Default value: '0600'

##### `auth_type`

Data type: `String`

Method used by PgBouncer to authenticate client connections
to PgBouncer. Values may be md5, crypt, plain, trust, or any.

Default value: 'trust'

##### `auth_list`

Data type: `Optional[Array]`

An array of auth values (user/password pairs).
This array is written to /var/lib/postgresql/pgbouncer.auth line by line.
Array entry format:
  "\"<username>\" \"<password\"

Default value: `undef`

##### `pool_mode`

Data type: `String`

Specifies when the server connection can be released back
into the pool. Values may be session, transaction, or statement.

Default value: 'transaction'

##### `default_pool_size`

Data type: `Integer`

The default connection pool size

Default value: 20

##### `autodb_idle_timeout`

Data type: `String`

If the automatically created (via “*”) database pools have been unused
this many seconds, they are freed. The negative aspect of that is that
their statistics are also forgotten. [seconds]

Default value: '3600'

##### `options`

Data type: `Hash`

Add your own custom extra options to the config file

Default value: {}

### pgbouncer::params

Parameters to be set for pgbouncer

